function IndiaMarket() {}

IndiaMarket.prototype = {
   autocheckInterval: 30,
   stockExchangeStr: "Bse"
}

IndiaMarket.prototype.initDialog = function() {
   //autocheck enabled ?
   document.getElementById('cbxAutoCheck').checked = this.getBoolPref("indiamarket.autocheck", true);

   //auto check time interval
   document.getElementById('Intervalbox').value = this.getStrPref("indiamarket.autocheckInterval", this.autocheckInterval);

   //exchange details. whether BSE or NSE
   document.getElementById('rdoExchange').selectedIndex = ( this.getStrPref("indiamarket.stockExchange",this.stockExchangeStr) == "Bse" )? 0 : 1;

   //stocks list
   var list = this.getPrefFilterList();
   var rules = document.getElementById('filterChilds');
   while (rules.hasChildNodes()) rules.removeChild(rules.firstChild);
   for (var i = 0; i < list.length; i++) {
      if (list[i] != "") {
         //alert(list[i]);
         var item = list[i].split("|");
         var sName = item[0];
         var sCode = item[1];
         if (!/^\/(.*)\/$/.exec(sName)) sName = sName.replace(/\/$/, "/*");
         if (!/^\/(.*)\/$/.exec(sCode)) sCode = sCode.replace(/\/$/, "/*");
         var enabled = (item[2] == "TRUE") ? true : false;
         this.addStock(sName, sCode,enabled);
      }
   }
   //general
   //document.getElementById('cbxAutoCheck').checked = this.getBoolPref("indiamarket.autocheck", true);

   //updateStatus
   //this.updateDialogPositions();
   this.updateDialogAllStatus();
   this.updateApplyButton(false);
}

IndiaMarket.prototype.updateApplyButton = function(e) {
   document.getElementById("myExtra1").disabled = !e;
}

IndiaMarket.prototype.init = function() {
   this.initDialog();
   this.addEventListenerByTagName("checkbox", "command", this.updateApplyButton);
   this.addEventListenerByTagName("radio", "command", this.updateApplyButton);
   this.addEventListener("filterChilds", "DOMAttrModified", this.updateApplyButton);
   this.addEventListener("filterChilds", "DOMNodeInserted", this.updateApplyButton);
   this.addEventListener("filterChilds", "DOMNodeRemoved", this.updateApplyButton);
   //this.addEventListener("parambox", "input", this.updateApplyButton);
   //this.addEventListener("toolsmenu", "command", this.updateToolsMenuStatus);
}
IndiaMarket.prototype.destory = function() {
   this.removeEventListenerByTagName("checkbox", "command", this.updateApplyButton);
   this.removeEventListenerByTagName("radio", "command", this.updateApplyButton);
   this.removeEventListener("filterChilds", "DOMAttrModified", this.updateApplyButton);
   this.removeEventListener("filterChilds", "DOMNodeInserted", this.updateApplyButton);
   this.removeEventListener("filterChilds", "DOMNodeRemoved", this.updateApplyButton);
//   this.removeEventListener("parambox", "input", this.updateApplyButton);
//   this.removeEventListener("toolsmenu", "command", this.updateToolsMenuStatus);
}

IndiaMarket.prototype.updateInterface = function() {
   var statusbar = this.getBoolPref("indiamarket.statusbar", true);
   var icon = (window.arguments ? window.arguments[1] : null); //get status-bar icon handle
   if (icon) this.setAttributeHidden(icon, statusbar);
}

IndiaMarket.prototype.setOptions = function() {
   //validate if the interval is less than 10 or greater than 1440 mins. if so set to 30 mins
   gIndiaMarket.validateInterval();

   //autocheck
   var autoCheck = document.getElementById('cbxAutoCheck').checked;
   this.setBoolPref("indiamarket.autocheck", autoCheck);
   //auto check time interval
   var Interval = document.getElementById('Intervalbox').value;
   this.setStrPref("indiamarket.autocheckInterval", Interval);

   //stocks List
   this.setStrPref("indiamarket.filterlist", this.getFilterListString());


   //this.setStrPref("indiamarket.stockExchange",  ( (document.getElementById('rdoBSE').selected) ? "Bse" : "Nse") );
   this.setStrPref("indiamarket.stockExchange",  ( (document.getElementById('rdoExchange').selectedIndex == 0) ? "Bse" : "Nse") );

   //update UI
   this.updateApplyButton(false);
   //this.updateInterface();


   /*
   if(pIndiaMarket=='undefined' || pIndiaMarket==null){
   	pIndiaMarket = new IndiaMarket();
   	pIndiaMarket.init();
   }*/
}

IndiaMarket.prototype.setAttributeHidden = function(obj, isHidden) {
   if (!obj) return;
   if (isHidden){
      obj.removeAttribute("hidden");
   }else{
      obj.setAttribute("hidden", true);
   }
}

IndiaMarket.prototype.getFilterListString = function() {
   var list = [];
   var filter = document.getElementById('filterList');
   var count = filter.view.rowCount;

   for (var i=0; i<count; i++) {
      var sName = filter.view.getCellText(i, filter.columns['columnStockName']);
      var sCode = filter.view.getCellText(i, filter.columns['columnStockCode']);
      var enabled = filter.view.getCellValue(i, filter.columns['columnEnabled']);
      var item = sName  +"|"+  sCode.toUpperCase()  +"|"+  (enabled=="true" ? "TRUE" : "FALSE");
      list.push(item);
   }
   list.sort();
   return list.join("|*|");
}


//*********************
IndiaMarket.prototype.getPrefFilterList = function() {
   var s = this.getStrPref("indiamarket.filterlist", null);
   return (s ? s.split("|*|") : "");
}

IndiaMarket.prototype.findName = function(value) {
   var filter = document.getElementById('filterList');
   var count = filter.view.rowCount;
   for (var i=0; i<count; i++) {
      var rule = filter.view.getCellText(i, filter.columns['columnStockName']);
      if (rule == value) return i;
   }
   return -1;
}

IndiaMarket.prototype.findCode = function(value) {
   var filter = document.getElementById('filterList');
   var count = filter.view.rowCount;
   for (var i=0; i<count; i++) {
      var rule = filter.view.getCellText(i, filter.columns['columnStockCode']);
      if (rule == value) return i;
   }
   return -1;
}


IndiaMarket.prototype.addStock = function(name,code, enabled) {
   var names = document.getElementById('filterChilds');
   var item = document.createElement('treeitem');
   var row = document.createElement('treerow');
   var c1 = document.createElement('treecell');
   var c2 = document.createElement('treecell');
   var c3 = document.createElement('treecell');
   c1.setAttribute('label', name);
   c2.setAttribute('label', code);
   c3.setAttribute('value', enabled);
   row.appendChild(c1);
   row.appendChild(c2);
   row.appendChild(c3);
   item.appendChild(row);
   names.appendChild(item);
   return (names.childNodes.length-1);
}
IndiaMarket.prototype.updateAddButtonStatus = function() {
   //var en = document.getElementById('cbxAutoCheck').checked;
   var addbtn = document.getElementById('addbtn');
   var namebox = document.getElementById('namebox');
   var codebox = document.getElementById('codebox');

   //addbtn.disabled = (!en) || (trim(namebox.value).length < 1) || (trim(codebox.value).length < 1);
   addbtn.disabled = (this.trim(namebox.value).length < 1) || (this.trim(codebox.value).length < 1) ;
}
IndiaMarket.prototype.updateDelButtonStatus = function(){
   var en = document.getElementById('cbxAutoCheck').checked;
   var delbtn = document.getElementById('delbtn');
   var filter = document.getElementById('filterList');
   delbtn.disabled = (!en) || (filter.view.selection.count < 1);
}
IndiaMarket.prototype.updateDialogAllStatus = function() {
   var en = document.getElementById('cbxAutoCheck').checked;
   document.getElementById('intervallabel').disabled = (!en);
   document.getElementById('Intervalbox').disabled = (!en);

   //document.getElementById('filterList').disabled = (!en);
   //document.getElementById('filterList').editable = (en);

   //document.getElementById('namelabel').disabled = (!en);
   //document.getElementById('namebox').disabled = (!en);

   //document.getElementById('codelabel').disabled = (!en);
   //document.getElementById('codebox').disabled = (!en);



   this.updateAddButtonStatus();
   this.updateDelButtonStatus();
}

//validate if the interval is less than 10 or greater than 1440 mins. if so set to 30 mins
IndiaMarket.prototype.validateInterval = function(){
   var Intervalbox = document.getElementById('Intervalbox');
   if(Intervalbox.value <10)
   	Intervalbox.value = 10; //10 mins
   else	if(Intervalbox.value >1440)
   	Intervalbox.value = 1440; //24 hrs
}

IndiaMarket.prototype.onClickFilterList = function(e) {
   var filter = document.getElementById('filterList');
   if (!filter.disabled && e.button == 0 && e.detail >= 2) {
      if (filter.view.selection.count == 1) {
         var namebox = document.getElementById('namebox');
         namebox.value = filter.view.getCellText(filter.currentIndex, filter.columns['columnStockName']);
         namebox.select();

         var codebox = document.getElementById('codebox');
         codebox.value = filter.view.getCellText(filter.currentIndex, filter.columns['columnStockCode']);
         codebox.select();

         this.updateAddButtonStatus();
      }
   }
}
 IndiaMarket.prototype.addNewStock = function() {
   var filter = document.getElementById('filterList');
   var namebox = document.getElementById('namebox');
   var codebox = document.getElementById('codebox');

   namebox.value = this.removeHTMLTags(namebox);
   codebox.value = this.removeHTMLTags(codebox);

   var name = this.trim(namebox.value);
   var code = this.trim(codebox.value);

   code = this.sanitizeStockCode(code); //remove unaccepted chars.  a-z only accepted

   name = this.sanitizeStockName(name); //remove unaccepted chars.  abcdefghijklmnopqrstuvwxyz 0123456789_- only accepted


   if( name != "" && code!= "" ) {
      var nameIdx = this.findName(name);
      var codeIdx = this.findCode(code);

      if(nameIdx == -1 && codeIdx == -1){
	       var idx = this.addStock(name,code.toUpperCase(),true);
	       namebox.value = "";
	       codebox.value = "";
      }

      filter.view.selection.select(idx);
      filter.boxObject.ensureRowIsVisible(idx);
   }
   filter.focus();
   this.updateAddButtonStatus();
}

IndiaMarket.prototype.delSelected = function() {
   var filter = document.getElementById('filterList');
   var rules = document.getElementById('filterChilds');
   if (filter.view.selection.count > 0) {
      for (var i=rules.childNodes.length-1 ; i>=0 ; i--) {
         if (filter.view.selection.isSelected(i))
            rules.removeChild(rules.childNodes[i]);
      }
   }
   this.updateDelButtonStatus();
}

//*********************** Utils **********************//
//-----------------------------------------------------------------------------

IndiaMarket.prototype.mlog = function(text) {
  Components.classes["@mozilla.org/consoleservice;1"]
    .getService(Components.interfaces.nsIConsoleService)
    .logStringMessage("IndiaMarket: "+text);
}

//-----------------------------------------------------------------------------

IndiaMarket.prototype.addEventListener = function(obj, type, listener) {
   if (typeof(obj) == "string") obj = document.getElementById(obj);
   if (obj) obj.addEventListener(type, listener, false);
}
IndiaMarket.prototype.removeEventListener = function(obj, type, listener) {
   if (typeof(obj) == "string") obj = document.getElementById(obj);
   if (obj) obj.removeEventListener(type, listener, false);
}

IndiaMarket.prototype.addEventListenerByTagName = function(tag, type, listener) {
   var objs = document.getElementsByTagName(tag);
   for (var i = 0; i < objs.length; i++) {
      objs[i].addEventListener(type, listener, false);
   }
}
IndiaMarket.prototype.removeEventListenerByTagName = function(tag, type, listener) {
   var objs = document.getElementsByTagName(tag);
   for (var i = 0; i < objs.length; i++) {
      objs[i].removeEventListener(type, listener, false);
   }
}

//-----------------------------------------------------------------------------

IndiaMarket.prototype.hookCode = function(orgFunc, orgCode, myCode) {
   if (orgFunc == "") return;
   switch (orgCode) {
   case "{":
      orgCode = /{/;
      myCode = "{"+myCode;
      break;
   case "}":
      orgCode = /}$/;
      myCode = myCode+"}";
      break;
   default:
   }
   try { eval(orgFunc + "=" + eval(orgFunc).toString().replace(orgCode, myCode)); }catch(e){ this.mlog("Failed to hook function: "+orgFunc); }
}

IndiaMarket.prototype.hookAttr = function(parentNode, attrName, myFunc) {
   if (typeof(parentNode) == "string") parentNode = document.getElementById(parentNode);
   try { parentNode.setAttribute(attrName, myFunc + parentNode.getAttribute(attrName)); }catch(e){ this.mlog("Failed to hook attribute: "+attrName); }
}

IndiaMarket.prototype.hookProp = function(parentNode, propName, myGetter, mySetter) {
   var oGetter = parentNode.__lookupGetter__(propName);
   var oSetter = parentNode.__lookupSetter__(propName);
   if (oGetter && myGetter) myGetter = oGetter.toString().replace(/{/, "{"+myGetter.toString().replace(/^.*{/,"").replace(/.*}$/,""));
   if (oSetter && mySetter) mySetter = oSetter.toString().replace(/{/, "{"+mySetter.toString().replace(/^.*{/,"").replace(/.*}$/,""));
   if (!myGetter) myGetter = oGetter;
   if (!mySetter) mySetter = oSetter;
   if (myGetter) try { eval('parentNode.__defineGetter__(propName, '+ myGetter.toString() +');'); }catch(e){ this.mlog("Failed to hook property Getter: "+propName); }
   if (mySetter) try { eval('parentNode.__defineSetter__(propName, '+ mySetter.toString() +');'); }catch(e){ this.mlog("Failed to hook property Setter: "+propName); }
}

//-----------------------------------------------------------------------------
//Function to trim the space in the  string
IndiaMarket.prototype.trim = function(s) {
   if (s) return s.replace(/^\s+/g,"").replace(/\s+$/g,""); else return "";
}
//Function to trim the space in the  string
IndiaMarket.prototype.startsWith = function(s, prefix) {
   if (s) return( (s.substring(0, prefix.length) == prefix) ); else return false;
}


//-----------------------------------------------------------------------------

IndiaMarket.prototype.getBoolPref = function(prefName, defval) {
   var result = defval;
   var prefservice = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
   var prefs = prefservice.getBranch("");
   if (prefs.getPrefType(prefName) == prefs.PREF_BOOL) {
       try { result = prefs.getBoolPref(prefName); }catch(e){}
   }
   return(result);
}

IndiaMarket.prototype.getIntPref = function(prefName, defval) {
   var result = defval;
   var prefservice = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
   var prefs = prefservice.getBranch("");
   if (prefs.getPrefType(prefName) == prefs.PREF_INT) {
       try { result = prefs.getIntPref(prefName); }catch(e){}
   }
   return(result);
}

IndiaMarket.prototype.getStrPref = function(prefName, defval) {
   var result = defval;
   var prefservice = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
   var prefs = prefservice.getBranch("");
   if (prefs.getPrefType(prefName) == prefs.PREF_STRING) {
       try { result = prefs.getComplexValue(prefName, Components.interfaces.nsISupportsString).data; }catch(e){}
   }
   return(result);
}


//-----------------------------------------------------------------------------

IndiaMarket.prototype.setBoolPref = function(prefName, value) {
   var prefservice = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
   var prefs = prefservice.getBranch("");
   try {
	   prefs.setBoolPref(prefName, value);
   }
   catch(e){
   }
}

IndiaMarket.prototype.setIntPref = function(prefName, value) {
   var prefservice = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
   var prefs = prefservice.getBranch("");
   try { prefs.setIntPref(prefName, value); } catch(e){}
}

IndiaMarket.prototype.setStrPref = function(prefName, value) {
   var prefservice = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
   var prefs = prefservice.getBranch("");
   var sString = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
   sString.data = value;
   try { prefs.setComplexValue(prefName, Components.interfaces.nsISupportsString, sString); } catch(e){}
}
//
//For Export and Import Settings, used the code from IEtab plugin is used.
//credits to the author(s) of IEtab
//-----------------------------------------------------------------------------
//EXPORT Settings
//-----------------------------------------------------------------------------
IndiaMarket.prototype.saveToFile = function(aList) {
   var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
   var stream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
   var converter = Components.classes["@mozilla.org/intl/converter-output-stream;1"].createInstance(Components.interfaces.nsIConverterOutputStream);

   fp.init(window, null, fp.modeSave);
   fp.defaultExtension = "txt";
   fp.defaultString = "IndiaMarketPref";
   fp.appendFilters(fp.filterText);

   if (fp.show() != fp.returnCancel) {
      try {
         if (fp.file.exists()) fp.file.remove(true);
         fp.file.create(fp.file.NORMAL_FILE_TYPE, 0666);
         stream.init(fp.file, 0x02, 0x200, null);
         converter.init(stream, "UTF-8", 0, 0x0000);

         for (var i = 0; i < aList.length ; i++) {
            aList[i] = aList[i] + "\n";
            converter.writeString(aList[i]);
         }
      } finally {
         converter.close();
         stream.close();
      }
   }
}
//-----------------------------------------------------------------------------

IndiaMarket.prototype.getAllSettings = function(isDefault) {
   var prefservice = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
   var prefs = (isDefault ? prefservice.getDefaultBranch("") : prefservice.getBranch("") );
   var preflist = prefs.getChildList("indiamarket.", {});

   var aList = ["IndiaMarketPref"];
   for (var i = 0 ; i < preflist.length ; i++) {
      try {
         var value = null;
         switch (prefs.getPrefType(preflist[i])) {
         case prefs.PREF_BOOL:
            value = prefs.getBoolPref(preflist[i]);
            break;
         case prefs.PREF_INT:
            value = prefs.getIntPref(preflist[i]);
            break;
         case prefs.PREF_STRING:
            value = prefs.getComplexValue(preflist[i], Components.interfaces.nsISupportsString).data;
            break;
         }
         aList.push(preflist[i] + "=" + value);
      } catch (e) {}
   }
   return aList;
}
//-----------------------------------------------------------------------------

IndiaMarket.prototype.exportSettings = function() {
   var aList = this.getAllSettings();
   if (aList) this.saveToFile(aList);
   alert("Exported Preferences Successfully.\nPlease Don't modify the File saved");
}
//-----------------------------------------------------------------------------
//IMPORT Settings
//-----------------------------------------------------------------------------
IndiaMarket.prototype.loadFromFile = function() {
   var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
   var stream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
   var converter = Components.classes["@mozilla.org/intl/converter-input-stream;1"].createInstance(Components.interfaces.nsIConverterInputStream);

   fp.init(window, null, fp.modeOpen);
   fp.defaultExtension = "txt";
   fp.appendFilters(fp.filterText);

   if (fp.show() != fp.returnCancel) {
      try {
         var input = {};
         stream.init(fp.file, 0x01, 0444, null);
         converter.init(stream, "UTF-8", 0, 0x0000);
         converter.readString(stream.available(), input);
         var linebreak = input.value.match(/(((\n+)|(\r+))+)/m)[1];
         return input.value.split(linebreak);
      } finally {
         converter.close();
         stream.close();
      }
   }
   return null;
}
//-----------------------------------------------------------------------------

IndiaMarket.prototype.setAllSettings = function(aList) {
   if (!aList) return;
   if (aList.length == 0) return;
   if (aList[0] != "IndiaMarketPref") return;

   var prefservice = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
   var prefs = prefservice.getBranch("");

   var aPrefs = [];
   for (var i = 1 ; i < aList.length ; i++){
      var index = aList[i].indexOf("=");
      if (index > 0){
         var name = aList[i].substring(0, index);
         var value = aList[i].substring(index+1, aList[i].length);
         if (this.startsWith(name, "indiamarket.")) aPrefs.push([name, value]);
      }
   }
   for (var i = 0 ; i < aPrefs.length ; i++) {
      try {
         var name = aPrefs[i][0];
         var value = aPrefs[i][1];
         switch (prefs.getPrefType(name)) {
         case prefs.PREF_BOOL:
            prefs.setBoolPref(name, /true/i.test(value));
            break;
         case prefs.PREF_INT:
            prefs.setIntPref(name, value);
            break;
         case prefs.PREF_STRING:
            if (value.indexOf('"') == 0) value = value.substring(1, value.length-1);
            var sString = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
            sString.data = value;
            prefs.setComplexValue(name, Components.interfaces.nsISupportsString, sString);
            break;
         }
      } catch (e) {}
   }
}

//-----------------------------------------------------------------------------
IndiaMarket.prototype.importSettings = function() {
   var aList = this.loadFromFile();
   if (aList) {
      this.setAllSettings(aList);
      this.initDialog();
      this.updateInterface();
      alert('Imported Preferences Successfully.\nPlease Restart your browser to load the new Stocks');
   }
}
//-----------------------------------------------------------------------------

IndiaMarket.prototype.getDefaultCharset = function(defval) {
   var charset = this.getStrPref("indiamarket.intl.charset.default", "");
   if (charset.length) return charset;
	var gPrefs = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch);
	if(gPrefs.prefHasUserValue("intl.charset.default")) {
	   return gPrefs.getCharPref("intl.charset.default");
	} else {
	   var strBundle = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
	   var intlMess = strBundle.createBundle("chrome://global-platform/locale/intl.properties");
	   try {
	      return intlMess.GetStringFromName("intl.charset.default");
	   } catch(e) {
   	   return defval;
      }
	}
}

IndiaMarket.prototype.convertToUTF8 = function(data, charset) {
   try {
      data = decodeURI(data);
   }catch(e){
      if (!charset) charset = gIndiaMarket.getDefaultCharset();
      if (charset) {
         var uc = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
         try {
            uc.charset = charset;
            data = uc.ConvertToUnicode(unescape(data));
            data = decodeURI(data);
         }catch(e){}
         uc.Finish();
      }
   }
   return data;
}

IndiaMarket.prototype.convertToASCII = function(data, charset) {
   if (!charset) charset = gIndiaMarket.getDefaultCharset();
   if (charset) {
      var uc = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
      uc.charset = charset;
      try {
         data = uc.ConvertFromUnicode(data);
      }catch(e){
         data = uc.ConvertToUnicode(unescape(data));
         data = decodeURI(data);
         data = uc.ConvertFromUnicode(data);
      }
      uc.Finish();
   }
   return data;
}

//-----------------------------------------------------------------------------

IndiaMarket.prototype.getUrlDomain = function(url) {
   if (url && !gIndiaMarket.startsWith(url, "about:")) {
      if (/^file:\/\/.*/.test(url)) return url;
      var matches = url.match(/^([A-Za-z]+:\/+)*([^\:^\/]+):?(\d*)(\/.*)*/);
      if (matches) url = matches[1]+matches[2]+(matches[3]==""?"":":"+matches[3])+"/";
   }
   return url;
}

IndiaMarket.prototype.getUrlHost = function(url) {
   if (url && !gIndiaMarket.startsWith(url, "about:")) {
      if (/^file:\/\/.*/.test(url)) return url;
      var matches = url.match(/^([A-Za-z]+:\/+)*([^\:^\/]+):?(\d*)(\/.*)*/);
      if (matches) url = matches[2];
   }
   return url;
}

//-----------------------------------------------------------------------------
IndiaMarket.prototype.removeHTMLTags = function(theid){
 	if(theid){
 		var strInputCode = theid.value;
 		/*
  			replaces escaped brackets with real ones,
  			i.e. &lt; is replaced with < and &gt; is replaced with >
 		*/
 	 	strInputCode = strInputCode.replace(/&(lt|gt);/g, function (strMatch, p1){
 		 	return (p1 == "lt")? "<" : ">";
 			}
 		);
 		//now remove the html/xml tags
 		strInputCode = strInputCode.replace(/<\/?[^>]+(>|$)/g, "");

   		return strInputCode;
 	}
}

IndiaMarket.prototype.sanitizeStockCode = function(strToTest) {
	var parsed = true;
	var str2Return = "";
	var validchars = "abcdefghijklmnopqrstuvwxyz";
	for (var i=0; i < strToTest.length; i++) {
		var letter = strToTest.charAt(i).toLowerCase();
		if (validchars.indexOf(letter) == -1) {
			//strToTest = strToTest.findandreplace(letter,''); //remove the char
		}else{
			str2Return += letter;
		}
	}
	str2Return = str2Return.findandreplace(" ",''); //remove intermediate spaces
 	return str2Return;
}
IndiaMarket.prototype.sanitizeStockName = function(strToTest) {
	var parsed = true;
	var str2Return = "";
	var validchars = "abcdefghijklmnopqrstuvwxyz 0123456789_-";
	for (var i=0; i < strToTest.length; i++) {
		var letter = strToTest.charAt(i).toLowerCase();
		if (validchars.indexOf(letter) == -1) {
			//strToTest = strToTest.findandreplace(letter,''); //remove the char
		}else{
			str2Return += letter;
		}
	}
	str2Return = str2Return.toProperCase();
	return str2Return;
}

var gIndiaMarket = new IndiaMarket();


String.prototype.findandreplace = function (find, replace) {
        var myString = this;
        var counter = 0;
        while (counter < myString.length) {
                var start = myString.indexOf(find, counter);
                if (start == -1) {
                        break;
                } else {
                        var before = myString.substr(0, start);
                        var after = myString.substr(start + find.length, myString.length);
                        myString = before + replace + after;
                        var counter = before.length + replace.length;
                }
        }
        return myString;
};

// proper case string prptotype (JScript 5.5+)
String.prototype.toProperCase = function()
{
  return this.toLowerCase().replace(/^(.)|\s(.)/g, function($1) { return $1.toUpperCase(); });
};
